#ifndef STATS_CONTEXT_TYPE_H__
#define STATS_CONTEXT_TYPE_H__

#include <cls.h>	/* FIXME: Unwanted include dependancy */

struct stats_context {
  int		do_sort;
  int		do_total_row;

  const char *	label;
  void		(*end_func)(struct stats_context *);
  void		(*configure_func)(struct stats_context *);
  void		(*calc_pre_func)(struct stats_context *);
  void		(*calc_func)(void *, void *);
  void		(*calc_post_func)(struct stats_context *);
  int		(*compr_func)(const void *, const void *);

  int		resultlist_sizegrow;
  int		resultlist_sizeone;

  /* filter */
  /* filter: include list; prim, exact, package-heir */
  /* filter: exclude list; prim, exact, package-heir */
  /* filter: top xyz cutoff */

  /* results */
  void **	resultlist;
  int		resultlist_size;		/* table size */
  int		resultlist_count;	/* returned results */
  int		resultlist_offset;
  int		resultlist_total;

  /* private data */
  union {
    struct class_usage {
      cls_usage	total[2];	/* cu hu */
      void *cls_total;
    } class_usage;
  } p;
};

typedef struct stats_context stats_context_t;

#endif /* STATS_CONTEXT_TYPE_H__ */

/* Emacs Local Variables: */
/* Emacs mode:C */
/* Emacs c-indentation-style:"gnu" */
/* Emacs c-hanging-braces-alist:((brace-list-open)(brace-entry-open)(defun-open after)(substatement-open after)(block-close . c-snug-do-while)(extern-lang-open after)) */
/* Emacs c-cleanup-list:(brace-else-brace brace-elseif-brace space-before-funcall) */
/* Emacs c-basic-offset:4 */
/* Emacs End: */
